'The program DQTEST perform the Dynamic Quantile (DQ) test for models that estimate VaR-values for returns. In order to run this program a work file needs to be open, with a return series r, a vector theta that contain the relevant VaR quantiles, a matrix var which contains corresponding VaR forecasts. The program "coverage tests" needs to be run before DQtest (to make the matrices lrhit and pe)

vector(t) dq ' vector with test statistics
vector(t) dqpvalue 'vector with pvalues

for !h = 1 to t
	!name = theta(!h)*100
	matrix(tf-4,6) x{!name} 'the number of rows in x{.} is tf-4 since we regress dqhit{.}against 4 of dqhit{.}'s lags, and dqhit{.} has tf values 
	vector(tf-4) dqhit{!name}

	for !i = 1 to tf-4
		x{!name}(!i,1) = 1
		dqhit{!name}(!i) = lrhit(!i+4,!h)-pe(!h)  'lrhit and pe are defined and created in coveragetest
		for !j = 2 to 5
			x{!name}(!i,!j) = lrhit(5+!i-!j,!h)-pe(!h)
		next
	x{!name}(!i,6) = var(!i+4,!h)
	next
	vector(6) beta{!name} = @inverse(@transpose(x{!name})*x{!name})*@transpose(x{!name})*dqhit{!name} 'the solution of the ordinary least squares equation: dqhit{.}_t = x{.}*beta{.}+u{.}_t

	vector dq{!name} = (@transpose(beta{!name})*@transpose(x{!name})*x{!name}*beta{!name})/(theta(!h)*(1-theta(!h))) 'dq{.} is the Dynamic Quantile test statistic

	dq(!h) = dq{!name}(1) 'saves the DQ test statistics in a vector dq that will contain the DQ test statistics for all VaR levels
	delete dq{!name} dqhit{!name} 'deletes variables that are not necessary to analyse results, to free memory and clean up workfile
	dqpvalue(!h) = @chisq(dq(!h),6)
next
show dqpvalue
