function CAViaR

%This is a parent program that calls all the other relevant programs 
%for estimation of the five CAViaR specifications:
%
%   1 = Symmetric Absolute Value
%   2 = Asymmetric Slope
%   3 = GARCH
%   4 = Adaptive
%   5 = AR-GARCH
%
%******************** WARNING ****************************************
% Remember to change the saving path in line 39 of this code, and the 
% loading path with corresponding variable in lines 34 and 35 of 
% CAViaROptimisation.m before running the program.
%*********************************************************************

tic %together with toc; calculates program run time
THETA = [1,5,10,90,95,99]; %VaR quantiles to estimate

for t = 1:size(THETA,2) % Loop through the THETA.
   for n = 1:5 % Loop through the models.
      
      %display the program's progress
      eval(['disp(','''','STAGE: ', 'THETA = ', int2str(THETA(t)),'%, ', 'MODEL = ', int2str(n),'''',')'])
      
      %calculate the model
      eval(['[output',int2str(n),'_',int2str(THETA(t)),']= CAViaROptimisation(',int2str(n),',',num2str(THETA(t)/100),');'])
      
      %create relevant tables
      eval(['UCpvalue(',int2str(t),',',int2str(n),')=output',int2str(n),'_',int2str(THETA(t)),'.UCpvalue;'])
      eval(['CCpvalue(',int2str(t),',',int2str(n),')=output',int2str(n),'_',int2str(THETA(t)),'.CCpvalue;'])
      eval(['DQpvalue(',int2str(t),',',int2str(n),')=output',int2str(n),'_',int2str(THETA(t)),'.DQpvalue;'])
      eval(['HitPercentage(',int2str(t),',',int2str(n),')=output',int2str(n),'_',int2str(THETA(t)),'.HitPercentage;'])
   end
end

clear n t THETA %clean up the workspace
save C:\Users\Torstein\Desktop\CAViaR_co2eex %save the workspace.
toc %together with tic; calculates program run time