function Ht = riskmetrics(data,lambda,backCast)

[T,k] = size(data);
if nargin<3
    backCast = zeros(k);
    endPoint = max(floor(min(log(.01)/log(lambda),T)),k);
    weights = (1-lambda).*lambda.^(0:endPoint-1);
    weights = weights/sum(weights);
    for i=1:endPoint
        backCast = backCast + weights(i)*data(i,:)'*data(i,:);
    end
end

Ht = zeros(k,k,T);
Ht(:,:,1) = backCast;
for i=2:T
    Ht(:,:,i) = (1-lambda)*data(i,:)'*data(i,:) + lambda * Ht(:,:,i-1);
end