function [LL, LLS, ht] = heavy_likelihood(parameters, data, p, q, backCasts, seriesIndex)

% parameters are 1+sum(P)+Q by 1
% data is T by 1
% backCasts is k by 1
% P is k by 1
% Q is scalar
% seriesIndex is 1 by 1

T = size(data,1);
K = length(p);
ht = backCasts(seriesIndex)*ones(T,1);
for t = 1:T
    for k = 1:K
        for i=1:p(k)
            if t-i<1
                ht(t) = ht(t) + parameters(count) * backCasts(i);
            else
                ht(t) = ht(t) + parameters(count) * data(t-i,i);
            end
        end
    end
    for i=1:q
        if t-i<1
            ht(t) = ht(t) + parameters(count) * backCasts(seriesIndex);
        else
            ht(t) = ht(t) + parameters(count) * ht(t-i);
        end
    end
end

LLS = log(ht) + data(:,seriesIndex./ht);
LL = sum(LLS);
